10 DIM X$(5),Y$(5)
20 DIM A(10,10),I4(8),J4(8),C$(8),D$(3)
30 PRINT 
40 PRINT "OTHELLO IS PLAYED ON AN 8 X 8 CHECKER BOARD,"
50 PRINT "ROWS NUMBERED 1 TO 8 AND COLUMNS A TO H."
60 PRINT "THE INITIAL CONFIGURATION IS ALL BLACK,EXCEPT"
70 PRINT "FOR THE CENTER FOUR SQUARES, WHICH FORM THE"
80 PRINT "PATTERN"
90 PRINT "           O X"
100 PRINT "           X O"
110 PRINT 
120 PRINT "TRY TO PLACE YOUR PIECE SO THAT IT 'OUTFLANKS'"
130 PRINT "MINE, CREATING A HORIZONTAL,VERTICAL, OR"
140 PRINT "DIAGONAL RUN OF MY PIECES BOUNDET AT EACH END"
150 PRINT "BY AT LEAST ONE OF YOURS. THIS WILL 'FLIP' MY"
160 PRINT "PIECES, TURNING THEM INTO YOURS."
170 PRINT "NOTE: YOU MUST CAPTURE AT LEAST ONE OF MY"
180 PRINT "PIECES IN THIS WAY IF IT IS AT ALL POSSIBLE."
190 PRINT "IF IT IS NOT POSSIBLE, YOU FORFEIT YOUR TURN BY"
200 PRINT "ENTERING 0,0 FOR YOUR ROW/COLUMN MOVE."
210 PRINT 
220 REM INITIALIZE
230 PRINT "SHOULD I WAIT BEFORE MAKING MY MOVES (Y OR N) "
240 LET F2=0
250 INPUT X$
260 IF X$="N" THEN  300
270 IF X$<>"Y" THEN  250
280 LET F2=1
290 PRINT "OK. TYPING ANY CHARACTER WILL LET ME GO."
300 PRINT "SHOULD I PLAY MY BEST STRATEGY (Y OR N) "
310 LET S2=0
320 INPUT X$
330 IF X$="N" THEN  360
340 IF X$<>"Y" THEN  320
350 LET S2=2
360 LET B=-1
370 LET W=1
380 LET D$(B+2)="X"
390 LET D$(0+2)="."
400 LET D$(W+2)="O"
410 FOR K=1 TO 8
420 READ I4(K)
430 NEXT K
440 DATA 0,-1,-1,-1,0,1,1,1
450 FOR K=1 TO 8
460 READ J4(K)
470 NEXT K
480 DATA 1,1,0,-1,-1,-1,0,1
490 FOR K=1 TO 8
500 READ C$(K)
510 NEXT K
520 DATA A,B,C,D,E,F,G,H
530 REM SET UP A NEW GAME
540 FOR I=1 TO 10
550 FOR J=1 TO 10
560 LET A(I,J)=0
570 NEXT J
580 NEXT I
590 LET A(5,5)=W
600 LET A(6,6)=W
610 LET A(5,6)=B
620 LET A(6,5)=B
630 LET C1=2
640 LET H1=2
650 LET N1=4
660 LET Z=0
670 REM HUMANS CHOICES
680 PRINT "DO YOU WANT TO HAVE X OR O ? "
690 LET C=W
700 LET H=B
710 INPUT X$
720 IF X$="X" THEN  760
730 IF X$<>"O" THEN  710
740 LET C=B
750 LET H=W
760 PRINT "DO YOU WANT TO GO FIRST (Y OR N) "
770 INPUT X$
780 IF X$="N" THEN  860
790 IF X$<>"Y" THEN  770
800 REM PRINT INITIAL BOARD
810 GOSUB 3000
820 GOTO 1540
830 REM COMPUTER'S MOVE
840 IF F2=0 THEN  860
850 INPUT X$
860 LET B1=-1
870 LET I3=0
880 LET J3=0
890 LET T1=C
900 LET T2=H
910 REM  SCAN FOR BLANK SQUARE
920 FOR I=2 TO 9
930 FOR J=2 TO 9
940 IF A(I,J)<>0 THEN 1230
950 REM  FOUND A BLANK SQUARE
960 REM  DOES IT HAVE AN OPPONENT AS A NEIGHBOR ?
970 GOSUB 2500
980 IF F1=0 THEN 1230
990 REM    FOUND AN OPPONENT AS A NEIGHBOR
1000 REM    HOW MANY OF HIS PIECES CAN WE 'FLIP'?
1010 REM    (DON'T DO IT NOW)
1020 LET U=-1
1030 GOSUB 2700
1040 REM   EXTRA POINTS FOR BOUNDARY POSITION
1050 IF S1=0 THEN 1230
1060 IF (I-2)*(I-9)<>0 THEN 1080
1070 LET S1=S1+S2
1080 IF (J-2)*(J-9)<>0 THEN 1110
1090 LET S1=S1+S2
1100 REM   IS THIS BETTER AS THE BEST FOUND SO FAR ?
1110 IF S1<B1 THEN 1230
1120 IF S1>B1 THEN 1190
1130 REM    A TIE; RANDOM DECISION
1140 REM    THE NEXT TWO EXECUTABLE STATEMENTS CAN BE DELETED
1150 REM    FOR A VERSION OF BASIC WITHOUT RANDOM NUMBERS
1160 LET R=RND
1170 IF R>.5 THEN 1230
1180 REM   YES
1190 LET B1=S1
1200 LET I3=I
1210 LET J3=J
1220 REM   END OF SCAN LOOP
1230 NEXT J
1240 NEXT I
1250 REM   COULD WE DO ANYTHING ?
1260 IF B1>0 THEN 1330
1270 REM   NO
1280 PRINT "I HAVE TO FORFEIT MY MOVE"
1290 IF Z=1 THEN 2060
1300 LET Z=1
1310 GOTO 1540
1320 REM    MAKE THE MOVE
1330 LET Z=0
1340 PRINT "I WILL MOVE TO ";
1350 PRINT I3-1;
1360 PRINT ",";
1370 PRINT C$(J3-1)
1380 LET I=I3
1390 LET J=J3
1400 LET U=1
1410 GOSUB 2700
1420 LET C1=C1+S1+1
1430 LET H1=H1-S1
1440 LET N1=N1+1
1450 PRINT "THAT GIVES ME ";
1460 PRINT S1;
1470 PRINT " OF YOUR PIECES"
1480 REM    PRINT OUT BOARD
1490 GOSUB 3000
1500 REM    TEST FOR END OF GAME
1510 IF H1=0 THEN 2060
1520 IF N1=64 THEN 2060
1530 REM  HUMAN'S MOVE
1540 LET T1=H
1550 LET T2=C
1560 PRINT "YOUR MOVE -- (ROW,COLUMN) "
1570 INPUT I,X$
1580 IF I<0 THEN 1570
1590 IF I>8 THEN 1570
1600 IF I<>0 THEN 1670
1610 PRINT "ARE YOU FORFEITING YOUR TURN (Y OR N) "
1620 INPUT X$
1630 IF X$<>"Y" THEN 1560
1640 IF Z=1 THEN 2060
1650 LET Z=1
1660 GOTO  840
1670 FOR Q=1 TO 8
1680 IF C$(Q)=X$ THEN 1720
1690 NEXT Q
1700 GOTO 1570
1710 REM    CHECK IF BLANK
1720 LET J=Q
1730 LET I=I+1
1740 LET J=J+1
1750 IF A(I,J)=0 THEN 1790
1760 PRINT "SORRY! THIS PLACE IS OCCUPIED. TRY AGAIN."
1770 GOTO 1570
1780 REM    CHECK FOR LEGAL NUMBERS
1790 GOSUB 2500
1800 IF F1=1 THEN 1840
1810 PRINT "SORRY! YOU ARE NOT NEXT TO ONE OF MY PIECES. TRY AGAIN."
1820 GOTO 1570
1830 REM    CHECK IF LEGAL RUN
1840 LET U=-1
1850 GOSUB 2700
1860 IF S1>0 THEN 1900
1870 PRINT "SORRY! THAT DOESN'T FLANK A ROW. TRY AGAIN."
1880 GOTO 1570
1890 REM   EVERYTHING LEGAL; MAKE HUMAN'S MOVE
1900 LET Z=0
1910 PRINT "THAT GIVES YOU ";
1920 PRINT S1;
1930 PRINT " OF MY PIECES"
1940 LET U=1
1950 GOSUB 2700
1960 LET H1=H1+S1+1
1970 LET C1=C1-S1
1980 LET N1=N1+1
1990 REM   PRINT OUT BOARD
2000 GOSUB 3000
2010 REM    TEST FOR END OF GAME
2020 IF C1=0 THEN 2060
2030 IF N1=64 THEN 2060
2040 GOTO  840
2050 REM    END OF GAME WRAPUP
2060 PRINT 
2070 PRINT "YOU HAVE ";
2080 PRINT H1;
2090 PRINT " PIECES AND I HAVE ";
2100 PRINT C1;
2110 PRINT " PIECES -- ";
2120 IF H1=C1 THEN 2160
2130 IF H1>C1 THEN 2180
2140 PRINT " SORRY! I WON THAT ONE."
2150 GOTO 2190
2160 PRINT "A TIE !!"
2170 GOTO 2370
2180 PRINT "YOU WON !"
2190 LET C1=C1-H1
2200 IF C1>0 THEN 2220
2210 LET C1=-C1
2220 LET C1=(64*C1)/N1
2230 PRINT "THAT WAS A ";
2240 IF C1<11 THEN 2360
2250 IF C1<25 THEN 2340
2260 IF C1<39 THEN 2320
2270 IF C1<53 THEN 2300
2280 PRINT "PERFECT GAME."
2290 GOTO 2370
2300 PRINT "WALKAWAY."
2310 GOTO 2370
2320 PRINT "FIGHT."
2330 GOTO 2370
2340 PRINT "HOT GAME !"
2350 GOTO 2370
2360 PRINT "SQUEAKER !!"
2370 PRINT 
2380 PRINT "DO YOU WANT TO PLAY ANOTHER GAME (Y OR N) "
2390 INPUT X$
2400 IF X$="Y" THEN  540
2410 IF X$<>"N" THEN 2390
2420 PRINT "THANKS FOR PLAYING !"
2430 STOP 
2440 REM
2450 REM ****************************************
2460 REM  SUBROUTINE TEST-FOR-PROPER-NEIGHBOR
2470 REM  ASSUMES:
2480 REM         I,J LOCATES A BLANK SQUARE
2490 REM         YOU HOPE TO SEE AN ADJACENT T2 (= -T1)
2500 LET F1=0
2510 FOR I1=-1 TO 1
2520 FOR J1=-1 TO 1
2530 IF A(I+I1,J+J1)=T2 THEN LET F1=1
2540 REM IF F1=1 SUCCESS
2550 NEXT J1
2560 NEXT I1
2570 REM IF F1=0 NO T2 FOUND ; FAILURE
2580 RETURN 
2590 REM
2600 REM ****************************************
2610 REM   SUBROUTINE SCORE-AND-UPDATE
2620 REM   ASSUMES:
2630 REM       (I,J) IS A TENTATIVE PLACE FOR A PIECE T1.
2640 REM       WANT RUNS OF T2 = -T1,TERMINATED BY A T1.
2650 REM       IF U IS TRUE (1),MARK THOSE RUNS AS T1'S.
2660 REM       RETURN SUM OF ALL RUNS (T2'S ONLY) IN S1.
2670 REM       MAIN PROGRAM CONTAINS THE FOLLOWING ARRAYS:
2680 REM           I4:  0 -1 -1 -1  0  1  1  1
2690 REM           J4:  1  1  0 -1 -1 -1  0  1
2700 LET S1=0
2710 FOR K=1 TO 8
2720 LET I5=I4(K)
2730 LET J5=J4(K)
2740 LET I6=I+I5
2750 LET J6=J+J5
2760 LET S3=0
2770 IF A(I6,J6)<>T2 THEN 2950
2780 REM    LOOP THROUGH THE RUN
2790 LET S3=S3+1
2800 LET I6=I6+I5
2810 LET J6=J6+J5
2820 IF A(I6,J6)=T1 THEN 2850
2830 IF A(I6,J6)=0 THEN 2950
2840 GOTO 2790
2850 LET S1=S1+S3
2860 IF U<>1 THEN 2950
2870 REM   UPDATE BOARD
2880 LET I6=I
2890 LET J6=J
2900 FOR K1=0 TO S3
2910 LET A(I6,J6)=T1
2920 LET I6=I6+I5
2930 LET J6=J6+J5
2940 NEXT K1
2950 NEXT K
2960 RETURN 
2970 REM
2980 REM ****************************************
2990 REM SUBROUTINE PRINT BOARD
3000 PRINT 
3010 PRINT "    A  B  C  D  E  F  G  H "
3020 FOR I=2 TO 9
3030 PRINT I-1;
3040 FOR J=2 TO 9
3050 PRINT "  ";
3060 PRINT D$(A(I,J)+2);
3070 NEXT J
3080 PRINT 
3090 NEXT I
3100 PRINT 
3110 RETURN 
3120 END 
